; A simple fire-routine in pure ASM (real mode).
; I have no idea where the pushed values ends up since there's no stack, it works-
; anyway so why bother...
; The random number generator was not written by me, I just modified it to work in
; real mode. It's probably pretty slow, but at least it works...
; Press [ESC] to exit the program.

 
.model tiny		;Not neccesary, but it's the correct way to do it
.386			;Enable 386 instructions	
code segment use16	;Set up the 64k segment in wich all code/data will reside
assume cs:code, ds:code	;Point cs and ds to this segment
org 0100h		;This line must be present in a .COM file

;*** <Main code> ***
start:		; <-- execution starts here 
mov ax,0013h	;set mode 19
int 10h

;*** <Palette stuff> ***
 mov si,OFFSET pal
 add si,3		;ds:[si] now points at color #1 (colors go from 0-255)
 mov bl,1
 mov dl,0
 ;*** Calculate the palette ***
  palloop:
  mov al,bl
  shl al,1
  dec al
  mov [si],al		;color[bl][red]=(2*bl)-1
  mov [si+1],dl		;color[bl][green]=0
  mov [si+2],dl		;color[bl][blue]=0
  mov [si+97],al	;color[bl+32][green]=(2*bl)-1
  mov [si+98],dl	;color[bl+32][blue]=0
  mov [si+194],al	;color[bl+64][blue]=(2*bl)-1
  add si,3
  inc bl
  cmp bl,33
 jne palloop

 mov si,OFFSET pal
 add si,3
 mov bx,1
 ;*** Set the palette ***
 setpal:
  mov dx,03c8h
  mov al,bl
  out dx,al		;Write color-# to port 3c8h
  mov dx,03c9h
  lodsb		
  out dx,al		;Red value
  lodsb
  out dx,al		;Green value
  lodsb
  out dx,al		;Blue value
  inc bx
  cmp bx,256
 jne setpal
;*** </Palette stuff> ***


;*** set es to point at VGA video memory ***
 mov ax,0a000h
 mov es,ax

mainloop:
 mov x,0
 mov si,12798		;(y*320)+x-2  	(x=0, y=40)
 mov di,12160		;((y-2)*320)+x 	(x=0, y=40)

;*** Draw column by column, left to right ***
 xloop:
  call fireproc
  mov bx,x
  call Random		;Get a random number	
  add ax,10		;Add 20 to random number
  mov es:[bx+64640],al	;Put a random pixel at es:[(202*320)+x]
  add si,2		;Add 2 to read-offset
  add di,2		;Add 2 to write-offset
  mov ax,x
  add ax,2		;Add 2 to x
  mov x,ax
  cmp ax,320		;End of screen ?
 jne xloop		;Nope, continue

 in al,60h		;Check for ESC key
 dec al
 jz quitnow		;If al=0 (ESC) then quit
jmp mainloop		;Continue

;*** Print a little message and shut down ***
 quitnow:
 mov ax,0003h		;Set textmode
 int 10h
 mov dx,OFFSET endmsg
 mov ah,09h
 int 21h

 mov ah,04ch		;Exit to OS
 int 21h
;*** </Main code> ***


;*** <Procedures> ***
 ;-----------------------------------------
 ;- Returns a random number in ax (0-191) -
 ;-----------------------------------------
 Random PROC NEAR
  push bx
  push si
  mov si,OFFSET random16
  xor bx,bx
  mov bl,seed1
  shl bx,1		;Multiply by 2 to get word-addressing
  mov ax,[si+bx]
  mov bl,seed2
  shl bx,1
  add ax,[si+bx]
  mov [si+bx],ax
  inc seed1
  and seed1,63
  inc seed2
  and seed2,63
  and ax,0bfh		;Cut ax to be max 191
  pop si 
  pop bx
  ret
 Random ENDP
 
 ;-------------------------------
 ;- Draw the fire to the screen -
 ;-------------------------------
 fireproc PROC NEAR
  push si
  push di
  push ds
  mov ax,0a000h
  mov ds,ax
  mov dl,40		;Start at y=40
  yloop:
  xor ax,ax
  lodsb			;si=(y*320)+x-2
  mov bx,ax
  inc si
  lodsb			;si=(y*320)+x
  add bx,ax
  inc si
  lodsb			;si=(y*320)+x+2
  add bx,ax
  add si,639
  lodsb			;si=((y+2)*320)+x+2
  add bx,ax
  shr bx,2
  cmp bx,0		;if color!=0 then
  je nopixeldec
  dec bx		; color=color-1		
  nopixeldec:		;end if
  mov ax,bx
  shl ax,8
  add ax,bx		;color=(color*256)+color
  stosw
  add di,318
  stosw
  sub si,5		;si=last si + 640
  add di,318		;di=last di + 640
  add dl,2
  cmp dl,202
  jbe yloop
  pop ds
  pop di
  pop si
  ret
 fireproc endp
;*** </Procedures> ***

;*** <Data> ***
 pal DB 768 DUP (63)	;256*3=768
 x DW 0
 y DB 0
 ;63 random 16-bit numbers for use with the random-number generator
 random16 dw 25662,56977,36314,46707
          dw 56747,47936,28467,50155
          dw 54470,9126,19191,26274
          dw 27205,13469,6769,48786
          dw 43195,17969,58549,13097
          dw 9962,26613,60724,25428
          dw 44416,43884,31777,40699
          dw 4280,32767,31882,41912
          dw 19050,42386,38267,39411
          dw 11739,36780,10921,43911
          dw 7473,38901,28614,62047
          dw 25094,22064,16149,14666
          dw 46209,34643,30017,25842
          dw 64242,3527,34102,35358
          dw 2277,3678,16479,3431
          dw 36135,63741,11311
 seed1 db 29
 seed2 db 63
 endmsg db 'Fire routine by Mic',13,10,'$'
;*** </Data> ***

code ends	;Segment ends here
END start	;End of program
